# Mining Multi-Label Samples from Single Positive Labels

The repository contains executable sources codes for S2M sampling introduced in the paper "Mining Multi-Label Samples from Single Positive Labels"

## Prerequisites

We tested our algorithm in the following environment:

```bash
Anaconda
python 3.8.5
pytorch 1.8.0
numpy 1.21.1
torchvision 0.9.0
```

## Running S2M Sampling

We prepare scripts for executing S2M sampling algorithm. To run the algorithm, you need to download checkpoints from [anonymized google drive](https://drive.google.com/drive/folders/1k0mqDruLnHNmrzlnrtOenN0YP_jeuubA?usp=sharing) and locate the checkpoints directory in the root directory of the project as follows:
```bash
┌── configs
├── scripts
├── src
└── checkpoints
    ├── SNGAN_cifar7to3
    ├── SNGAN_celeba7to3
    ├── cGAN_cifar7to3
    └── cGAN_celeba7to3
```

If you run the scripts below, sampling results on cifar-10 7to3 and CelebaA 7to3 will be saved in the results directory.

```bash
sh scripts/cgan_cifar7to3.sh
sh scripts/sngan_cifar7to3.sh
sh scripts/cgan_celeba7to3.sh
sh scripts/sngan_celeba7to3.sh
```